package com.huimv.guowei.admin.utils;

import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.huimv.guowei.admin.entity.*;
import com.huimv.guowei.admin.entity.vo.EnergyWaterVo;
import com.huimv.guowei.admin.entity.vo.EnvRegularCallEggVo;
import com.huimv.guowei.admin.entity.vo.WaterVo;
import org.jxls.common.Context;
import org.jxls.util.JxlsHelper;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Print {
    /**
     * 打印方法  不插入图片
     *
     * @return
     * @throws Exception
     */
    public static void printDuck(List<PrintEntrty> printEntrties) throws Exception {

        //准备数据
        String path = "/opt/guowei/duck.xls";
        //获取模板文件，你自己当前模板的位置  我这里为当前项目下
        InputStream is = new FileInputStream("/opt/guowei/duck.xlsx");
        //根据模板生成的文件保存路径  我这里保存在本地D盘
        OutputStream os = new FileOutputStream(path);
        //绑定数据
        Context context = new Context();
        List<PrintEntrtyVo> list = new ArrayList<>();
        for (PrintEntrty printEntrty : printEntrties) {
            PrintEntrtyVo printEntrtyVo = new PrintEntrtyVo();
            BaseDuckInfo duckInfo = printEntrty.getBaseDuckInfo();
            printEntrtyVo.setDuckCode(duckInfo.getChiNum()+"、"+duckInfo.getJiaoNum());

            if (duckInfo.getDuckBreed() == 1) {
                printEntrtyVo.setDuckType("北京鸭");
            } else if (duckInfo.getDuckBreed() == 2) {
                printEntrtyVo.setDuckType("连城白鸭");
            } else if (duckInfo.getDuckBreed() == 3) {
                printEntrtyVo.setDuckType("山麻鸭");

            } else if (duckInfo.getDuckBreed() == 4) {
                printEntrtyVo.setDuckType("攸县麻鸭");

            } else if (duckInfo.getDuckBreed() == 5) {
                printEntrtyVo.setDuckType("白改鸭");

            } else if (duckInfo.getDuckBreed() == 6) {
                printEntrtyVo.setDuckType("缙云麻鸭");

            } else if (duckInfo.getDuckBreed() == 7) {
                printEntrtyVo.setDuckType("绍兴鸭(带圈白翼梢)");

            } else if (duckInfo.getDuckBreed() == 8) {
                printEntrtyVo.setDuckType("绍兴鸭(红毛绿翼梢)");

            } else if (duckInfo.getDuckBreed() == 9) {
                printEntrtyVo.setDuckType("绍兴鸭(白羽绍鸭)");

            }

            if (duckInfo.getDuckSex() == 0) {
                printEntrtyVo.setDuckSex("雄");
            } else {
                printEntrtyVo.setDuckSex("雌");
            }

            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
            printEntrtyVo.setDuckDate(sdf.format(duckInfo.getDuckBirthday()));

            printEntrtyVo.setAddress(duckInfo.getDuckBirthplace());

            printEntrtyVo.setFather(duckInfo.getFatherNum());

            printEntrtyVo.setFather2(duckInfo.getFatherGenotype());

            printEntrtyVo.setMother(duckInfo.getMotherNum());

            printEntrtyVo.setMother2(duckInfo.getMotherGenotype());


            String s = "";
            String s1 = "";
            String s2 = "";
            List<DuckHealthInfo> healthInfos = printEntrty.getDuckHealthInfos();
            //健康状况
            for (DuckHealthInfo healthInfo : healthInfos) {
                if ("".equals(healthInfo.getDiseaseName()) || null == healthInfo.getDiseaseName()) {
                    s1 = sdf.format(healthInfo.getHealthDate()) + "无" + ";" + "\n" + s1;
                } else {
                    s1 = sdf.format(healthInfo.getHealthDate()) + " " + healthInfo.getDiseaseName() + ";" + "\n" + s1;
                }
            }
            List<EnvMoveCall> envMoveCalls = printEntrty.getEnvMoveCalls();
            //日龄体重
            for (EnvMoveCall envMoveCall : envMoveCalls) {
                if ("".equals(envMoveCall.getDayage()) || null == envMoveCall.getDayage()) {
                    s = "0" + "日龄 体重" + ":" + envMoveCall.getDuckWeight() + "KG;" + "\n" + s;
                } else {
                    s = envMoveCall.getDayage() + "日龄 体重" + ":" + envMoveCall.getDuckWeight() + "KG;" + "\n" + s;
                }

            }
            List<DuckImmunityInfo> immunityInfos = printEntrty.getDuckImmunityInfos();
            //免疫记录
            for (DuckImmunityInfo immunityInfo : immunityInfos) {
                if (("").equals(immunityInfo.getVaccination()) || null == immunityInfo.getVaccination()) {
                    s2 = sdf.format(immunityInfo.getHealthDate()) + "  无;" + "\n" + s2;
                } else {
                    s2 = sdf.format(immunityInfo.getHealthDate()) + " " + immunityInfo.getVaccination() + ";" + "\n" + s2;
                }

            }

            printEntrtyVo.setWeight(s);
            printEntrtyVo.setNeed(duckInfo.getSpecialNeeds());
            printEntrtyVo.setEnv(duckInfo.getBreedingEnv());
            printEntrtyVo.setRecord(s1);
            printEntrtyVo.setRecord2(s2);
            list.add(printEntrtyVo);
        }

        context.putVar("list", list);
        //生成
        JxlsHelper.getInstance().processTemplate(is, os, context);
    }

    public static void printEgg(List<EnvRegularCallEggVo> eggs) throws Exception {

        //准备数据
        String path = "/opt/guowei/egg.xls";
        //获取模板文件，你自己当前模板的位置  我这里为当前项目下
        InputStream is = new FileInputStream("/opt/guowei/egg.xlsx");
        //根据模板生成的文件保存路径  我这里保存在本地D盘
        OutputStream os = new FileOutputStream(path);
        //绑定数据
        Context context = new Context();
        List<EnvRegularCallEggVo> list = new ArrayList<>();
        for (EnvRegularCallEggVo egg : eggs) {
            EnvRegularCallEggVo eggVo = new EnvRegularCallEggVo();
            eggVo.setEggNum(egg.getEggNum());
            eggVo.setDuckCode(egg.getDuckCode());
            eggVo.setDate(egg.getDate());
            eggVo.setFeed(egg.getFeed());
            eggVo.setWeight(egg.getWeight());
            list.add(eggVo);
        }
        context.putVar("list", list);
        //生成
        JxlsHelper.getInstance().processTemplate(is, os, context);
    }

    public static void printWater(List<EnergyWater> waterVos,EnergyWater water) throws Exception {

        //准备数据
        String path = "/opt/guowei/water.xls";
        //获取模板文件，你自己当前模板的位置  我这里为当前项目下
        InputStream is = new FileInputStream("/opt/guowei/water.xlsx");
        //根据模板生成的文件保存路径  我这里保存在本地D盘
        OutputStream os = new FileOutputStream(path);
        //绑定数据
        Context context = new Context();
        List<WaterVo> list = new ArrayList<>();
        int i = 0;
        BigDecimal count = BigDecimal.ZERO;
        for (EnergyWater waterVo : waterVos) {
            i=i+1;
            WaterVo waterVo1 = new WaterVo();
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
            String format = sdf.format(waterVo.getCreateDate());
            waterVo1.setDate(format);
            waterVo1.setLocation(waterVo.getChipName());
            waterVo1.setWater(waterVo.getWaterValue());
            BigDecimal bd = new BigDecimal(waterVo.getWaterValue());
            BigDecimal result = bd.setScale(2, BigDecimal.ROUND_HALF_UP);
            count = count.add(result);
            list.add(waterVo1);
            if (i == 4) {
                WaterVo one = new WaterVo();
                one.setDate(format);
                one.setLocation("合计：");
                one.setWater(count.toString());
                list.add(one);
                i = 0;
            }
        }
        context.putVar("list", list);
        context.putVar("waterCount", water.getWaterValue());
        //生成
        JxlsHelper.getInstance().processTemplate(is, os, context);
    }

    public static void printElectricity(List<EnergyWaterVo> waterVos) throws Exception {

        //准备数据
        String path = "/opt/guowei/electricity.xls";
        //获取模板文件，你自己当前模板的位置  我这里为当前项目下
        InputStream is = new FileInputStream("/opt/guowei/electricity.xlsx");
        //根据模板生成的文件保存路径  我这里保存在本地D盘
        OutputStream os = new FileOutputStream(path);
        //绑定数据
        Context context = new Context();
        List<WaterVo> list = new ArrayList<>();
        for (EnergyWaterVo waterVo : waterVos) {
            WaterVo waterVo1 = new WaterVo();
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
            waterVo1.setDate(sdf.format(waterVo.getCreateDate()));
            waterVo1.setLocation(waterVo.getChipName());
            waterVo1.setWater(waterVo.getWaterValue().toString());
            list.add(waterVo1);
        }
        context.putVar("list", list);
        //生成
        JxlsHelper.getInstance().processTemplate(is, os, context);
    }
    public static void printChi(List<BaseDuckInfo> baseDuckInfos) throws Exception {

        //准备数据
        String path = "/opt/guowei/chi.xls";
        //获取模板文件，你自己当前模板的位置  我这里为当前项目下
        InputStream is = new FileInputStream("/opt/guowei/chi.xlsx");
        //根据模板生成的文件保存路径  我这里保存在本地D盘
        OutputStream os = new FileOutputStream(path);
        //绑定数据
        Context context = new Context();
        List<PrintEntrtyChi> list = new ArrayList<>();
        for (BaseDuckInfo baseDuckInfo : baseDuckInfos) {
            PrintEntrtyChi printEntrtyChi = new PrintEntrtyChi();
            printEntrtyChi.setUnitName(baseDuckInfo.getUnitName());
            printEntrtyChi.setChiNum(baseDuckInfo.getChiNum());
            printEntrtyChi.setJiaoNum(baseDuckInfo.getJiaoNum());
            list.add(printEntrtyChi);
        }

        context.putVar("list", list);
        //生成
        JxlsHelper.getInstance().processTemplate(is, os, context);
    }
}